==== Patch <commit-11012008a> level 1
Source: [No source]
Target: a8845c50-7012-0410-95d3-8e1449b9b1e4:/trunk/mifos:12249
        (https://mifos.dev.java.net/svn/mifos/trunk/mifos)
Log:
commit for 11/01
Index: BirtWebViewer/webcontent/birt/pages/parameter/HiddenParameterFragment.jsp
==================================================================
--- BirtWebViewer/webcontent/birt/pages/parameter/HiddenParameterFragment.jsp	(revision 12249)

+++ BirtWebViewer/webcontent/birt/pages/parameter/HiddenParameterFragment.jsp	(patch commit-11012008a level 1)

@@ -37,6 +37,19 @@

 		<INPUT TYPE="HIDDEN"
 			NAME="<%= encodedParameterName %>"
 			VALUE="<%= value %>"/>		
+		    <!-- For Mifos Birt report -->
+		    <font class="fontnormalRedBold">
+		    <%
+			    String message = request.getParameter("mifosErrorMessage");
+	 		    if (message != null && request.getAttribute("errorHasBeenShown") == null) { 
+	 		        request.setAttribute("errorHasBeenShown", "true");			    		 		    
+			    	String[] messages = message.split("~");
+			    	for(int i=0;i<messages.length;i++){	    
+			    		out.println("<li>" + messages[i] + "</li>");
+			    	}
+			    }
+		    %>
+		    </font>						
 	</TD>
 </TR>
 
Index: src/org/mifos/application/NamedQueryConstants.java
==================================================================
--- src/org/mifos/application/NamedQueryConstants.java	(revision 12249)

+++ src/org/mifos/application/NamedQueryConstants.java	(patch commit-11012008a level 1)

@@ -340,6 +340,17 @@

 
 	public String MASTERDATA_ACTIVE_BRANCHES = "masterdata.activeBranches";
 	public String GET_FIELD_TYPE = "getFieldType";
+	
+	public static final String COLLECTION_SHEET_FOR_SPECIFIED_CUSTOMER = "collectionSheet.getCollectionSheetForCenterWithSpecifiedMeetingDate";
+	public static final String COLLECTION_SHEETS_FOR_MEETING_DATE = "collectionSheet.getCollectionSheetForMeetingDate";
+	public static final String COLLECTION_SHEET_CUSTOMERS_ON_MEETING_DATE_FOR_LOAN_OFFICER = "CollectionSheetCustomer.collectionSheetForSpecifiedMeetingDateAndLoanOfficer";
+	public static final String COLLECTION_SHEET_CUSTOMERS_ON_MEETING_DATE = "CollectionSheetCustomer.collectionSheetForSpecifiedMeetingDate";
+	public static final String COLLECTION_SHEETS_OF_CHILDREN_ON_MEETING_DATE = "CollectionSheetCustomer.collectionSheetOfCustomersUnderAParentForSpecifiedMeetingDate";
+	public static final String GET_ACTIVE_BRANCHES_AS_SELECTION_ITEM = "SelectionItem.get_active_offices";
+	public static final String GET_ACTIVE_LOAN_OFFICERS_UNDER_OFFICE_AS_SELECTION_ITEM = "SelectionItem.get_active_loanofficers_under_office";
+	public static final String GET_ACTIVE_CUSTOMERS_UNDER_LOAN_OFFICER_AS_SELECTION_ITEM = "SelectionItem.get_active_customers_under_loanofficers";
+	public static final String GET_MEETING_DATES_AS_SELECTION_ITEM = "DateSelectionItem.get_meeting_dates";
+	
 	/**M2 queries*/
 	/**Personnel Queries*/
 	public String MASTERDATA_ACTIVE_LOANOFFICERS_INBRANCH = "masterdata.activeloanofficers";
Index: src/org/mifos/application/accounts/loan/business/LoanBO.java
==================================================================
--- src/org/mifos/application/accounts/loan/business/LoanBO.java	(revision 12249)

+++ src/org/mifos/application/accounts/loan/business/LoanBO.java	(patch commit-11012008a level 1)

@@ -206,20 +206,29 @@

 	private Short recurMonth;
 	
 
-	protected LoanBO() {
-		super();
-		this.loanOffering = null;
-		this.loanSummary = null;
+	protected LoanBO() {		
+		this(null, null, null, null, null);
 		this.loanPrdPersistence = null;
-		this.performanceHistory = null;
 		this.loanActivityDetails = new HashSet<LoanActivityEntity>();
         this.redone = false;
- 		this.maxMinLoanAmount = null;
-		this.maxMinNoOfInstall = null;
     	parentAccount=null;
     	loanAccountDetails=new HashSet<LoanBO>();
 	}
+	
+	public LoanBO(LoanOfferingBO loanOffering){
+		this(loanOffering, null, null, null, null);
+	}
 
+	private LoanBO(LoanOfferingBO loanOffering, LoanSummaryEntity loanSummary, MaxMinLoanAmount maxMinLoanAmount, 
+			MaxMinNoOfInstall maxMinNoOfInstall, LoanPerformanceHistoryEntity performanceHistory) {
+		this.loanOffering = loanOffering;
+		this.loanSummary = loanSummary;
+		this.maxMinLoanAmount = maxMinLoanAmount;
+		this.maxMinNoOfInstall = maxMinNoOfInstall;
+		this.performanceHistory = performanceHistory;		
+	}
+	
+
 	public static LoanBO redoLoan(UserContext userContext,
 			LoanOfferingBO loanOffering, CustomerBO customer,
 			AccountState accountState, Money loanAmount,
@@ -3406,7 +3415,8 @@

 	public RankType getWeekRank() {
 		return monthRank!=null ? RankType.getRankType(monthRank.getId()) : null;
 	}
-	
 
-	
+	public boolean isOfProductOffering(LoanOfferingBO loanOfferingBO) {
+		return this.loanOffering.equals(loanOfferingBO);
+	}
 }
Index: src/org/mifos/application/accounts/savings/business/SavingsBO.java
==================================================================
--- src/org/mifos/application/accounts/savings/business/SavingsBO.java	(revision 12249)

+++ src/org/mifos/application/accounts/savings/business/SavingsBO.java	(patch commit-11012008a level 1)

@@ -137,6 +137,11 @@

 		savingsActivityDetails = new HashSet<SavingsActivityEntity>();
 	}
 
+	public SavingsBO(SavingsOfferingBO savingsOffering) {
+		this.savingsOffering = savingsOffering;
+		
+	}
+
 	public Money getRecommendedAmount() {
 		return recommendedAmount;
 	}
@@ -2144,4 +2149,8 @@

 		}else
 			return trxnDate.equals(DateUtils.getCurrentDateWithoutTimeStamp());
 	}
+
+	public boolean isOfProductOffering(SavingsOfferingBO productOffering) {
+		return savingsOffering.equals(productOffering);
+	}
 }
Index: src/org/mifos/application/collectionsheet/business/CollSheetCustBO.java
==================================================================
--- src/org/mifos/application/collectionsheet/business/CollSheetCustBO.java	(revision 12249)

+++ src/org/mifos/application/collectionsheet/business/CollSheetCustBO.java	(patch commit-11012008a level 1)

@@ -96,6 +96,24 @@

 	
 	private Short loanOfficerId ;
 	
+	public CollSheetCustBO(Integer custId, String custDisplayName,
+			Short custLevel, Short custOfficeId, String searchId, Short loanOfficerId) {
+		super();
+		this.custId = custId;
+		this.custDisplayName = custDisplayName;
+		this.custLevel = custLevel;
+		this.custOfficeId = custOfficeId;
+		this.searchId = searchId;
+		this.loanOfficerId = loanOfficerId;
+		collectionSheetLoanDetails = new HashSet<CollSheetLnDetailsEntity>();
+		collSheetSavingsDetails = new HashSet<CollSheetSavingsDetailsEntity>();
+	}
+
+	public CollSheetCustBO() {
+		this(null, null, null, null, null, null);
+	}
+
+
 	public Long getCollSheetCustId() {
 		return collSheetCustId;
 	}
Index: src/org/mifos/application/collectionsheet/business/CollSheetLnDetailsEntity.java
==================================================================
--- src/org/mifos/application/collectionsheet/business/CollSheetLnDetailsEntity.java	(revision 12249)

+++ src/org/mifos/application/collectionsheet/business/CollSheetLnDetailsEntity.java	(patch commit-11012008a level 1)

@@ -37,6 +37,8 @@

  */
 package org.mifos.application.collectionsheet.business;
 
+import java.io.Serializable;
+
 import org.mifos.application.accounts.business.AccountActionDateEntity;
 import org.mifos.application.accounts.loan.business.LoanBO;
 import org.mifos.application.accounts.loan.business.LoanScheduleEntity;
@@ -49,6 +51,7 @@

 import org.mifos.framework.exceptions.ApplicationException;
 import org.mifos.framework.exceptions.SystemException;
 import org.mifos.framework.util.helpers.Money;
+import org.mifos.framework.util.helpers.MoneyUtils;
 
 public class CollSheetLnDetailsEntity extends PersistentObject {
 
@@ -290,7 +293,8 @@

 	public void addAccountDetails(AccountActionDateEntity accountActionDate)
 			throws SystemException, ApplicationException {
 		LoanScheduleEntity loanSchedule = (LoanScheduleEntity) accountActionDate;
-		LoanBO loan = new LoanPersistence().getAccount(loanSchedule.getAccount().getAccountId());
+		LoanBO loan = new LoanPersistence().getAccount(loanSchedule
+				.getAccount().getAccountId());
 		this.accountId = loanSchedule.getAccount().getAccountId();
 		this.currentInstallmentNo = loanSchedule.getInstallmentId();
 		MifosLogManager.getLogger(LoggerConstants.COLLECTIONSHEETLOGGER).debug(
@@ -333,7 +337,8 @@

 				&& null != collectionSheetLoanDetailsObj.getLoanDetailsId()) {
 			return loanDetailsId.equals(collectionSheetLoanDetailsObj
 					.getLoanDetailsId());
-		} else if (null != this.collectionSheetCustomer
+		}
+		else if (null != this.collectionSheetCustomer
 				&& null != collectionSheetLoanDetailsObj
 						.getCollectionSheetCustomer()) {
 			return this.accountId.equals(collectionSheetLoanDetailsObj
@@ -341,7 +346,8 @@

 					&& this.collectionSheetCustomer
 							.equals(collectionSheetLoanDetailsObj
 									.getCollectionSheetCustomer());
-		} else {
+		}
+		else {
 			return super.equals(collectionSheetLoanDetailsObj);
 		}
 
@@ -356,15 +362,17 @@

 	 * This sets accountId,amntToBeDisbursed and sets installment id to null
 	 * because installments haven't begun yet.
 	 */
-    public void addDisbursalDetails(LoanBO loan) {
-		MifosLogManager.getLogger(LoggerConstants.COLLECTIONSHEETLOGGER).debug("inside add disbursaldetails");
-		
+	public void addDisbursalDetails(LoanBO loan) {
+		MifosLogManager.getLogger(LoggerConstants.COLLECTIONSHEETLOGGER).debug(
+				"inside add disbursaldetails");
+
 		this.accountId = loan.getAccountId();
 		// TODO check in case of interest deducted at disbursement this should
 		// show the loan amount to be disbursed.
 		this.amntToBeDisbursed = loan.getLoanAmount();
-		if(loan.isInterestDeductedAtDisbursement()){
-			LoanScheduleEntity loanSchedule = (LoanScheduleEntity)loan.getAccountActionDate(CollectionSheetConstants.FIRST_INSTALLMENT);
+		if (loan.isInterestDeductedAtDisbursement()) {
+			LoanScheduleEntity loanSchedule = (LoanScheduleEntity) loan
+					.getAccountActionDate(CollectionSheetConstants.FIRST_INSTALLMENT);
 			this.interestDue = loanSchedule.getInterestDue();
 			this.feesDue = loanSchedule.getTotalFeeDue();
 		}
@@ -373,4 +381,12 @@

 		this.originalLoanAmnt = loan.getLoanAmount();
 		this.totalPrincipalDue = this.originalLoanAmnt;
 	}
+
+	public Money getTotalFees() {
+		return MoneyUtils.add(getFeesDue(), getFeesOverDue());
+	}
+
+	public Money getTotalPenalty() {
+		return MoneyUtils.add(getPenaltyDue(), getPenaltyOverDue());
+	}
 }
Index: src/org/mifos/application/collectionsheet/business/CollectionSheetBO.java
==================================================================
--- src/org/mifos/application/collectionsheet/business/CollectionSheetBO.java	(revision 12249)

+++ src/org/mifos/application/collectionsheet/business/CollectionSheetBO.java	(patch commit-11012008a level 1)

@@ -71,6 +71,17 @@

 
 	private Set<CollSheetCustBO> collectionSheetCustomers;
 
+	public CollectionSheetBO(Date collSheetDate, Date runDate, Set<CollSheetCustBO> collectionSheetCustomers, Short statusFlag) {
+		super();
+		this.collSheetDate = collSheetDate;
+		this.runDate = runDate;
+		this.collectionSheetCustomers = collectionSheetCustomers;
+		this.statusFlag = statusFlag;
+		for(CollSheetCustBO customer: collectionSheetCustomers) {
+			customer.setCollectionSheet(this);
+		}
+	}
+
 	public Date getCollSheetDate() {
 		return collSheetDate;
 	}
Index: src/org/mifos/application/customer/business/CustomerBO.java
==================================================================
--- src/org/mifos/application/customer/business/CustomerBO.java	(revision 12249)

+++ src/org/mifos/application/customer/business/CustomerBO.java	(patch commit-11012008a level 1)

@@ -152,13 +152,21 @@

 	private Set<CustomerBO> children;
 
 	protected CustomerBO() {
-		super();
-		this.customerId = null;
+		this(null, null, null, null, null);
 		this.globalCustNum = null;
-		this.customerLevel = null;
-		this.formedByPersonnel = null;
 	}
 
+	
+	public CustomerBO(Integer customerId, CustomerLevelEntity customerLevel, PersonnelBO formedByPersonnel, PersonnelBO personnel, String displayName) {
+		super();
+		this.customerId = customerId;
+		this.customerLevel = customerLevel;
+		this.formedByPersonnel = formedByPersonnel;
+		this.personnel = personnel;
+		this.displayName = displayName;
+	}
+
+
 	protected CustomerBO(UserContext userContext, String displayName,
 			CustomerLevel customerLevel, CustomerStatus customerStatus,
 			String externalId, Date mfiJoiningDate, Address address,
Index: src/org/mifos/application/customer/center/business/CenterBO.java
==================================================================
--- src/org/mifos/application/customer/center/business/CenterBO.java	(revision 12249)

+++ src/org/mifos/application/customer/center/business/CenterBO.java	(patch commit-11012008a level 1)

@@ -10,6 +10,7 @@

 import org.mifos.application.configuration.exceptions.ConfigurationException;
 import org.mifos.application.configuration.util.helpers.ConfigurationConstants;
 import org.mifos.application.customer.business.CustomerBO;
+import org.mifos.application.customer.business.CustomerLevelEntity;
 import org.mifos.application.customer.business.CustomerPerformanceHistory;
 import org.mifos.application.customer.business.CustomerPositionView;
 import org.mifos.application.customer.center.persistence.CenterPersistence;
@@ -23,6 +24,7 @@

 import org.mifos.application.fees.business.FeeView;
 import org.mifos.application.master.business.CustomFieldView;
 import org.mifos.application.meeting.business.MeetingBO;
+import org.mifos.application.personnel.business.PersonnelBO;
 import org.mifos.framework.business.util.Address;
 import org.mifos.framework.components.logger.LoggerConstants;
 import org.mifos.framework.components.logger.MifosLogManager;
@@ -33,7 +35,6 @@

 public class CenterBO extends CustomerBO {
 
 	private MifosLogger logger = MifosLogManager.getLogger(LoggerConstants.CENTERLOGGER);
-	
 	public CenterBO(UserContext userContext, String displayName,
 			Address address, List<CustomFieldView> customFields,
 			List<FeeView> fees, String externalId, Date mfiJoiningDate,
@@ -59,6 +60,10 @@

 		super();
 	}
 	
+	public CenterBO(Integer customerId, CustomerLevelEntity customerLevel, PersonnelBO formedByPersonnel, PersonnelBO personnel, String displayName) {
+		super(customerId, customerLevel, formedByPersonnel, personnel, displayName);
+	}
+	
 	@Override
 	public boolean isActive() {
 		return getStatus() == CustomerStatus.CENTER_ACTIVE;
Index: src/org/mifos/application/customer/group/business/GroupBO.java
==================================================================
--- src/org/mifos/application/customer/group/business/GroupBO.java	(revision 12249)

+++ src/org/mifos/application/customer/group/business/GroupBO.java	(patch commit-11012008a level 1)

@@ -47,6 +47,7 @@

 import org.mifos.application.configuration.util.helpers.ConfigurationConstants;
 import org.mifos.application.customer.business.CustomerBO;
 import org.mifos.application.customer.business.CustomerHierarchyEntity;
+import org.mifos.application.customer.business.CustomerLevelEntity;
 import org.mifos.application.customer.business.CustomerPositionView;
 import org.mifos.application.customer.business.CustomerStatusEntity;
 import org.mifos.application.customer.center.business.CenterBO;
@@ -64,10 +65,10 @@

 import org.mifos.application.meeting.business.MeetingBO;
 import org.mifos.application.office.business.OfficeBO;
 import org.mifos.application.office.persistence.OfficePersistence;
+import org.mifos.application.personnel.business.PersonnelBO;
 import org.mifos.application.util.helpers.YesNoFlag;
 import org.mifos.config.ClientRules;
 import org.mifos.framework.business.util.Address;
-import org.mifos.framework.components.configuration.business.Configuration;
 import org.mifos.framework.components.logger.LoggerConstants;
 import org.mifos.framework.components.logger.MifosLogManager;
 import org.mifos.framework.components.logger.MifosLogger;
@@ -131,6 +132,10 @@

 				officeId, parentCustomer, meeting, loanOfficerId);
 		validateFields(displayName, formedById, trained, trainedDate);
 	}
+	
+	public GroupBO(int customerId, CustomerLevelEntity customerLevel, PersonnelBO formedByPersonnel, PersonnelBO personnel, String displayName) {
+		super(customerId, customerLevel, formedByPersonnel, personnel, displayName);
+	}	
 
 	@Override
 	public boolean isActive() {
Index: src/org/mifos/application/office/business/OfficeBO.java
==================================================================
--- src/org/mifos/application/office/business/OfficeBO.java	(revision 12249)

+++ src/org/mifos/application/office/business/OfficeBO.java	(patch commit-11012008a level 1)

@@ -60,10 +60,7 @@

 	private Set<OfficeBO> children;
 
 	public OfficeBO() {
-		super();
-		maxChildCount = null;
-		officeId = null;
-		operationMode = null;
+		this(null, null, null, null);
 		status = new OfficeStatusEntity(OfficeStatus.ACTIVE);
 		address = new OfficeAddressEntity();
 	}
@@ -145,6 +142,14 @@

 		verifyFields(officeName, shortName, level, operationMode, parentOffice);
 	}
 
+	public OfficeBO(Short officeId, String officeName, Integer maxChildCount, Short operationMode) {
+		super();
+		this.officeId = officeId;
+		this.officeName = officeName;
+		this.maxChildCount = maxChildCount;
+		this.operationMode = operationMode;
+	}
+
 	@Override
 	public void setCreatedDate(Date createdDate) {
 		this.createdDate = createdDate;
Index: src/org/mifos/application/personnel/business/PersonnelBO.java
==================================================================
--- src/org/mifos/application/personnel/business/PersonnelBO.java	(revision 12249)

+++ src/org/mifos/application/personnel/business/PersonnelBO.java	(patch commit-11012008a level 1)

@@ -1,5 +1,7 @@

 package org.mifos.application.personnel.business;
 
+import static org.mifos.application.reports.util.helpers.ReportsConstants.*;
+
 import java.util.ArrayList;
 import java.util.Date;
 import java.util.HashSet;
@@ -20,6 +22,7 @@

 import org.mifos.application.personnel.util.helpers.PersonnelConstants;
 import org.mifos.application.personnel.util.helpers.PersonnelLevel;
 import org.mifos.application.personnel.util.helpers.PersonnelStatus;
+import org.mifos.application.reports.util.helpers.ReportsConstants;
 import org.mifos.application.rolesandpermission.business.RoleBO;
 import org.mifos.config.Localization;
 import org.mifos.framework.business.BusinessObject;
@@ -85,7 +88,7 @@

 	private Set<PersonnelNotesEntity> personnelNotes;
 
 	private MifosLogger logger = MifosLogManager.getLogger(LoggerConstants.PERSONNEL_LOGGER);
-	
+
 	public static PersonnelBO ALL_PERSONNEL = new PersonnelBO();
 	static {
 		ALL_PERSONNEL.setDisplayName("ALL");
@@ -139,15 +142,20 @@

 	}
 
 	PersonnelBO() {
-		this.level = null;
+		this(null, null, null, null);
 		this.personnelDetails = new PersonnelDetailsEntity();
 		this.preferredLocale = new SupportedLocalesEntity();
 		this.customFields = new HashSet<PersonnelCustomFieldEntity>();
 		this.personnelNotes = new HashSet<PersonnelNotesEntity>();
-		this.personnelId = null;
-		this.userName = null;
 	}
 
+	public PersonnelBO(Short personnelId, String userName, String displayName, PersonnelLevelEntity level) {
+		this.personnelId = personnelId;
+		this.userName = userName;
+		this.displayName = displayName;
+		this.level = level;
+	}
+
 	public String getAge() {
 		if (this.personnelDetails != null
 				&& this.personnelDetails.getDob() != null
Index: src/org/mifos/application/personnel/business/PersonnelLevelEntity.java
==================================================================
--- src/org/mifos/application/personnel/business/PersonnelLevelEntity.java	(revision 12249)

+++ src/org/mifos/application/personnel/business/PersonnelLevelEntity.java	(patch commit-11012008a level 1)

@@ -12,6 +12,9 @@

 
 	private final PersonnelLevelEntity parent;
 
+	public static final PersonnelLevelEntity NON_LOAN_OFFICER_LEVEL_ENTITY = new PersonnelLevelEntity(
+			PersonnelLevel.NON_LOAN_OFFICER);
+
 	public PersonnelLevelEntity(PersonnelLevel level) {
 		super(level.getValue());
 		this.parent = null;
@@ -31,8 +34,8 @@

 		return parent;
 	}
 
-    @Override
+	@Override
 	public String toString() {
-        return PersonnelLevel.fromInt(getId()).toString();
-    }
+		return PersonnelLevel.fromInt(getId()).toString();
+	}
 }
Index: src/org/mifos/application/productdefinition/business/LoanOfferingBO.java
==================================================================
--- src/org/mifos/application/productdefinition/business/LoanOfferingBO.java	(revision 12249)

+++ src/org/mifos/application/productdefinition/business/LoanOfferingBO.java	(patch commit-11012008a level 1)

@@ -55,6 +55,7 @@

 import org.mifos.application.meeting.exceptions.MeetingException;
 import org.mifos.application.meeting.util.helpers.MeetingType;
 import org.mifos.application.meeting.util.helpers.RecurrenceType;
+import org.mifos.application.office.business.OfficeBO;
 import org.mifos.application.productdefinition.exceptions.ProductDefinitionException;
 import org.mifos.application.productdefinition.persistence.LoanPrdPersistence;
 import org.mifos.application.productdefinition.struts.actionforms.LoanPrdActionForm;
@@ -358,18 +359,40 @@

 	}
 
 	protected LoanOfferingBO() {
-		principalGLcode = null;
-		interestGLcode = null;
-		loanOfferingFunds = new HashSet<LoanOfferingFundEntity>();
-		loanOfferingFees = new HashSet<LoanOfferingFeesEntity>();
-		loanAmountFromLastLoan = new HashSet<LoanAmountFromLastLoanAmountBO>();
-		loanAmountFromLoanCycle = new HashSet<LoanAmountFromLoanCycleBO>();
-		noOfInstallFromLastLoan = new HashSet<NoOfInstallFromLastLoanAmountBO>();
-		noOfInstallFromLoanCycle = new HashSet<NoOfInstallFromLoanCycleBO>();
-		loanAmountSameForAllLoan = new HashSet<LoanAmountSameForAllLoanBO>();
-		noOfInstallSameForAllLoan = new HashSet<NoOfInstallSameForAllLoanBO>();
+		this(null, null, null, null, null, null, new HashSet<LoanOfferingFundEntity>(), 
+				new HashSet<LoanOfferingFeesEntity>(), new HashSet<LoanAmountFromLastLoanAmountBO>(), 
+				new HashSet<LoanAmountFromLoanCycleBO>(), new HashSet<NoOfInstallFromLastLoanAmountBO>(), 
+				new HashSet<NoOfInstallFromLoanCycleBO>(), new HashSet<LoanAmountSameForAllLoanBO>(), 
+				new HashSet<NoOfInstallSameForAllLoanBO>());
+	}
 
+	private LoanOfferingBO(Short prdOfferingId, String globalPrdOfferingNum, 
+			ProductTypeEntity prdType, OfficeBO office,
+			GLCodeEntity principalGLcode, 
+			GLCodeEntity interestGLcode, 
+			Set<LoanOfferingFundEntity> loanOfferingFunds, 
+			Set<LoanOfferingFeesEntity> loanOfferingFees, 
+			Set<LoanAmountFromLastLoanAmountBO> loanAmountFromLastLoan, 
+			Set<LoanAmountFromLoanCycleBO> loanAmountFromLoanCycle, Set<NoOfInstallFromLastLoanAmountBO> noOfInstallFromLastLoan, Set<NoOfInstallFromLoanCycleBO> noOfInstallFromLoanCycle, Set<LoanAmountSameForAllLoanBO> loanAmountSameForAllLoan, Set<NoOfInstallSameForAllLoanBO> noOfInstallSameForAllLoan) {
+		super(prdOfferingId, globalPrdOfferingNum, prdType, office);
+		this.principalGLcode = principalGLcode;
+		this.interestGLcode = interestGLcode;
+		this.loanOfferingFunds = loanOfferingFunds;
+		this.loanOfferingFees = loanOfferingFees;
+		this.loanAmountFromLastLoan = loanAmountFromLastLoan;
+		this.loanAmountFromLoanCycle = loanAmountFromLoanCycle;
+		this.noOfInstallFromLastLoan = noOfInstallFromLastLoan;
+		this.noOfInstallFromLoanCycle = noOfInstallFromLoanCycle;
+		this.loanAmountSameForAllLoan = loanAmountSameForAllLoan;
+		this.noOfInstallSameForAllLoan = noOfInstallSameForAllLoan;
+	}
 
+	public LoanOfferingBO(Short prdOfferingId) {
+		this(prdOfferingId, null, null, null, null, null, new HashSet<LoanOfferingFundEntity>(), 
+				new HashSet<LoanOfferingFeesEntity>(), new HashSet<LoanAmountFromLastLoanAmountBO>(), 
+				new HashSet<LoanAmountFromLoanCycleBO>(), new HashSet<NoOfInstallFromLastLoanAmountBO>(), 
+				new HashSet<NoOfInstallFromLoanCycleBO>(), new HashSet<LoanAmountSameForAllLoanBO>(), 
+				new HashSet<NoOfInstallSameForAllLoanBO>());
 	}
 
 	public GracePeriodTypeEntity getGracePeriodType() {
Index: src/org/mifos/application/productdefinition/business/PrdOfferingBO.java
==================================================================
--- src/org/mifos/application/productdefinition/business/PrdOfferingBO.java	(revision 12249)

+++ src/org/mifos/application/productdefinition/business/PrdOfferingBO.java	(patch commit-11012008a level 1)

@@ -103,14 +103,19 @@

 			.getLogger(LoggerConstants.PRDDEFINITIONLOGGER);
 
 	protected PrdOfferingBO() {
-		prdOfferingId = null;
-		globalPrdOfferingNum = null;
-		prdType = null;
-		office = null;
+		this(null, null, null, null);
 		prdApplicableMaster = null;
 		collectionProductMix=null;
 		prdOfferingNotAllowedId=null;
 	}
+	
+	protected PrdOfferingBO(Short prdOfferingId, String globalPrdOfferingNum, ProductTypeEntity prdType,
+			OfficeBO office){
+		this.prdOfferingId = prdOfferingId;
+		this.globalPrdOfferingNum = globalPrdOfferingNum;
+		this.prdType = prdType;
+		this.office = office;		
+	}
 
 	protected PrdOfferingBO(UserContext userContext, String prdOfferingName,
 			String prdOfferingShortName, ProductCategoryBO prdCategory,
@@ -154,6 +159,10 @@

 		prdLogger.debug("creating product offering done");
 	}
 
+	public PrdOfferingBO(Short prdOfferingId) {
+		this(prdOfferingId, null, null, null);		
+	}
+
 	public Short getPrdOfferingId() {
 		return prdOfferingId;
 	}
@@ -458,4 +467,30 @@

 		this.setPrdMixFlag(YesNoFlag.YES.getValue());
 		new PrdOfferingPersistence().createOrUpdate(this);
 	}
+
+	@Override
+	public int hashCode() {
+		final int PRIME = 31;
+		int result = 1;
+		result = PRIME * result + ((prdOfferingId == null) ? 0 : prdOfferingId.hashCode());
+		return result;
+	}
+
+	@Override
+	public boolean equals(Object obj) {
+		if (this == obj)
+			return true;
+		if (obj == null)
+			return false;
+		if (getClass() != obj.getClass())
+			return false;
+		final PrdOfferingBO other = (PrdOfferingBO) obj;
+		if (prdOfferingId == null) {
+			if (other.prdOfferingId != null)
+				return false;
+		}
+		else if (!prdOfferingId.equals(other.prdOfferingId))
+			return false;
+		return true;
+	}
 }
Index: src/org/mifos/application/productdefinition/business/SavingsOfferingBO.java
==================================================================
--- src/org/mifos/application/productdefinition/business/SavingsOfferingBO.java	(revision 12249)

+++ src/org/mifos/application/productdefinition/business/SavingsOfferingBO.java	(patch commit-11012008a level 1)

@@ -83,6 +83,10 @@

 	private MifosLogger prdLogger = MifosLogManager
 			.getLogger(LoggerConstants.PRDDEFINITIONLOGGER);
 
+	public SavingsOfferingBO(){
+		this(null, null, null, new HashSet<PrdOfferingMeetingEntity>());
+	}
+	
 	public SavingsOfferingBO(UserContext userContext, String prdOfferingName,
 			String prdOfferingShortName, ProductCategoryBO prdCategory,
 			PrdApplicableMasterEntity prdApplicableMaster, Date startDate,
@@ -137,11 +141,17 @@

 				+ getGlobalPrdOfferingNum());
 	}
 
-	protected SavingsOfferingBO() {
-		depositGLCode = null;
-		interestGLCode = null;
-		savingsOfferingMeetings = new HashSet<PrdOfferingMeetingEntity>();
+	protected SavingsOfferingBO(Short prdOfferingId, GLCodeEntity depositGLCode, 
+			GLCodeEntity interestGLCode, HashSet<PrdOfferingMeetingEntity> savingsOfferingMeetings) {
+		super(prdOfferingId);
+		this.depositGLCode = depositGLCode;
+		this.interestGLCode = interestGLCode;
+		this.savingsOfferingMeetings = savingsOfferingMeetings;
 	}
+	
+	public SavingsOfferingBO(Short prdOfferingId){
+		this(prdOfferingId, null, null, new HashSet<PrdOfferingMeetingEntity>());
+	}
 
 	private Set<PrdOfferingMeetingEntity> getSavingsOfferingMeetings() {
 		return savingsOfferingMeetings;
Index: src/org/mifos/application/reports/util/helpers/ReportsConstants.java
==================================================================
--- src/org/mifos/application/reports/util/helpers/ReportsConstants.java	(revision 12249)

+++ src/org/mifos/application/reports/util/helpers/ReportsConstants.java	(patch commit-11012008a level 1)

@@ -38,6 +38,8 @@

 
 package org.mifos.application.reports.util.helpers;
 
+import java.util.Date;
+
 public interface ReportsConstants {
 	public String GETPATH_REPORTS="reportsAction";
 	public String GETREPORTPAGE="getReportPage";
@@ -81,6 +83,13 @@

 	public static final String ERROR_REPORTALREADYEXIST="error.reportAlreadyExist";
 	public static final String ERROR_REPORTACTIVITYIDISNULL="error.reportActivityIdIsNull";
 	public static final String ERROR_NOMOREDYNAMICACTIVITYID="error.noMoreDynamicActivityId";
-	
-	
+//added by collection sheet report module
+	public static final String SELECT_DISPLAY_NAME = "---Select---";
+	public static final String NOT_APPLICABLE_DISPLAY_NAME = "---N/A---";
+	public static final String ALL_DISPLAY_NAME = "ALL";
+	public static final Short NOT_APPLICABLE_ID = new Short("-3");
+	public static final Short SELECT_ID = new Short("-2");
+	public static final Short ALL_ID = new Short("-1");
+	public static final Date NA_DATE = new Date(0l);
+//ended by collection sheet report module
 }
